; 
    .nolist
     include \masm32\include\masm32rt.inc
    .686
    include counter2.asm
    .listall
    PRIORITY_CLASS equ HIGH_PRIORITY_CLASS
    ;PRIORITY_CLASS equ REALTIME_PRIORITY_CLASS
    REPEAT_COUNT equ 20
; 

    ; -------------------------------------------------------
    ; This is an assembly-time random number generator based
    ; on code by George Marsaglia:
    ;   #define znew  ((z=36969*(z&65535)+(z>>16))<<16)
    ;   #define wnew  ((w=18000*(w&65535)+(w>>16))&65535)
    ;   #define MWC   (znew+wnew)
    ; -------------------------------------------------------

    @seed MACRO
      @znew_seed@ = 362436069
      @wnew_seed@ = 521288629
    ENDM

    @seed

    @rnd MACRO base:REQ
      LOCAL znew, wnew

      @znew_seed@ = 36969 * (@znew_seed@ AND 65535) + (@znew_seed@ SHR 16)
      znew = @znew_seed@ SHL 16

      @wnew_seed@ = 18000 * (@wnew_seed@ AND 65535) + (@wnew_seed@ SHR 16)
      wnew = @wnew_seed@ AND 65535

      EXITM <(znew + wnew) MOD base>
    ENDM

; 

    ; herge.

    abs0 MACRO
        push eax
        and eax, 80000000h
        cmp eax, 80000000h
        pop eax
        jnz @f
        neg eax
      @@:
    ENDM

    ; evlncrn8, reply #1.

    abs1 MACRO
        test eax, 80000000h
        jz @F
        neg eax
      @@:
    ENDM

    ; jimg, reply #2.

    abs2 MACRO
        or eax, eax
        jns @F
        neg eax
      @@:
    ENDM

    ; Rockoon, reply #5, modified to leave result in eax for function test.

    abs3t MACRO
        mov ebx, eax
        sar eax, 31
        add ebx, eax
        xor ebx, eax
        mov eax, ebx
    ENDM

    ; Rockoon, reply #5

    abs3 MACRO
        mov ebx, eax
        sar eax, 31
        add ebx, eax
        xor ebx, eax
    ENDM

    ; drizz, reply #7.

    abs4 MACRO
        cdq
        xor eax,edx
        sub eax,edx
    ENDM

    ; jj2007, reply #22,

    abs5 MACRO
      .if eax>=80000000h
        neg eax
      .endif
    ENDM

    ; hutch, reply #19.
    
    abs6 MACRO
        mov ecx, eax
        neg ecx
        test eax, eax
        cmovs eax, ecx
    ENDM

    ; hutch, reply #19.

    abs7 MACRO
        add eax, 0
        jns @F
        neg eax
      @@:
    ENDM

    ; NightWare, reply #24, modified to receive and return in eax.

    abs8 MACRO
        test eax, eax
        jns @F
        neg eax
      @@:
    ENDM

    ; NightWare, reply #24, modified to receive and return in eax.

    abs9 MACRO
        bt eax,31
        jnc @F
        neg eax
      @@:
    ENDM

    abs10 Macro
        mov edx,eax
        neg edx
        cmovns eax,edx
    endm
; 
    .data
    .code
; 
start:
; 

    crtabs MACRO
      invoke crt_abs, eax
    ENDM

    ; ---------------
    ; Function tests.
    ; ---------------

    FOR mac,<abs0,abs1,abs2,abs3t,abs4,abs5,abs6,abs7,abs8,abs9,abs10,crtabs>
      print "&mac",9
      mov eax, 0
      mac
      print ustr$(eax)," "
      mov eax, 1
      mac
      print ustr$(eax)," "
      mov eax, 2147483647
      mac
      print ustr$(eax)," "
      mov eax, -1
      mac
      print ustr$(eax)," "
      mov eax, -2147483648
      abstrt=$
      mac
      absize = $ - abstrt
      print ustr$(eax),"  size="
      mov eax,absize
      print ustr$(eax),13,10
    ENDM
    print chr$(13,10)    

    macx MACRO mac,desc
      @seed
      ctr_begin 1000, PRIORITY_CLASS
        REPEAT REPEAT_COUNT
          mov eax, @rnd(0ffffffffh)
          mac
        ENDM
      ctr_end
      print ustr$(eax), " cycles, &mac (&desc)",13,10
    endm


    REPEAT 5

      invoke Sleep, 4000

        macx <abs0>,<herge>
        macx <abs1>,<evlncrn8>
        macx <abs2>,<jimg>
        macx <abs3>,<Rockoon>
        macx <abs4>,<drizz>
        macx <abs5>,<jj2007>
        macx <abs6>,<hutch1>
        macx <abs7>,<hutch2>
        macx <abs8>,<NightWare1>
        macx <abs9>,<NightWare2>
        macx <abs10>,<jimg2>
        macx <crtabs>,<crt_abs>
        print " ",13,10
    ENDM

    inkey "Press any key to exit..."
    exit
; 
end start
